//
//  Emoji.swift
//  Pachyderm
//
//  Created by Shadowfacts on 9/8/18.
//  Copyright © 2018 Shadowfacts. All rights reserved.
//

import Foundation

public class Emoji: Decodable {
    public let shortcode: String
    public let url: URL
    public let staticURL: URL
    public let visibleInPicker: Bool
    
    private enum CodingKeys: String, CodingKey {
        case shortcode
        case url
        case staticURL = "static_url"
        case visibleInPicker = "visible_in_picker"
    }
}

extension Emoji: CustomDebugStringConvertible {
    public var debugDescription: String {
        return ":\(shortcode):"
    }
}
