//
//  Relationship.swift
//  Pachyderm
//
//  Created by Shadowfacts on 9/9/18.
//  Copyright © 2018 Shadowfacts. All rights reserved.
//

import Foundation

public class Relationship: Decodable {
    public let id: String
    public let following: Bool
    public let followedBy: Bool
    public let blocking: Bool
    public let muting: Bool
    public let mutingNotifications: Bool
    public let followRequested: Bool
    public let domainBlocking: Bool
    public let showingReblogs: Bool
    
    private enum CodingKeys: String, CodingKey {
        case id
        case following
        case followedBy = "followed_by"
        case blocking
        case muting
        case mutingNotifications = "muting_notifications"
        case followRequested = "requested"
        case domainBlocking = "domain_blocking"
        case showingReblogs = "showing_reblogs"
    }
}
