//  AppearancePrefsView.swift
//  Tusker
//
//  Created by Shadowfacts on 6/13/19.
//  Copyright © 2019 Shadowfacts. All rights reserved.
//

import SwiftUI

struct AppearancePrefsView : View {
    @ObservedObject var preferences = Preferences.shared

    var useCircularAvatars: Binding<Bool> = Binding(get: {
        Preferences.shared.avatarStyle == .circle
    }) {
        Preferences.shared.avatarStyle = $0 ? .circle : .roundRect
    }

    var body: some View {
        List {
            Toggle(isOn: $preferences.showRepliesInProfiles) {
                Text("Show Replies in Profiles")
            }
            Toggle(isOn: useCircularAvatars) {
                Text("Use Circular Avatars")
            }
            Toggle(isOn: $preferences.hideCustomEmojiInUsernames) {
                Text("Hide Custom Emoji in Usernames")
            }
        }
            .listStyle(GroupedListStyle())
            .navigationBarTitle(Text("Appearance"))
    }
}

#if DEBUG
struct AppearancePrefsView_Previews : PreviewProvider {
    static var previews: some View {
        AppearancePrefsView()
    }
}
#endif
