//
//  TimelinesPageViewController.swift
//  Tusker
//
//  Created by Shadowfacts on 9/14/19.
//  Copyright © 2019 Shadowfacts. All rights reserved.
//

import UIKit

class TimelinesPageViewController: SegmentedPageViewController {

    private let homeTitle = NSLocalizedString("Home", comment: "home timeline tab title")
    private let federatedTitle = NSLocalizedString("Federated", comment: "federated timeline tab title")
    private let localTitle = NSLocalizedString("Local", comment: "local timeline tab title")
    
    init() {
        let home = TimelineTableViewController(for: .home)
        home.title = homeTitle
        
        let federated = TimelineTableViewController(for: .public(local: false))
        federated.title = federatedTitle
        
        let local = TimelineTableViewController(for: .public(local: true))
        local.title = localTitle
        
        super.init(titles: [
            homeTitle,
            federatedTitle,
            localTitle
        ], pageControllers: [
            home,
            federated,
            local
        ])
        
        title = homeTitle
        tabBarItem.image = UIImage(systemName: "house.fill")
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

}
